/*--------------------------------------------------------------------
This source distribution is placed in the public domain by its author,
Jason Papadopoulos. You may use it for any purpose, free of charge,
without having to notify anyone. I disclaim any responsibility for any
errors.

Optionally, please be nice and tell me if you find this source to be
useful. Again optionally, if you add to the functionality present here
please consider making those additions public too, so that others may 
benefit from your work.	
       				   --jasonp@boo.net 9/24/08
--------------------------------------------------------------------*/

#ifdef HAVE_GMP

#ifndef _GMP_XFACE_H_
#define _GMP_XFACE_H_

#include <util.h>
#include <gmp.h>
#include <mp.h>

#ifdef __cplusplus
extern "C" {
#endif

/*--------------------------------------------------------------------*/
static INLINE void mp2gmp(mp_t *src, mpz_t dest) {

	mpz_import(dest, (size_t)(src->nwords), -1, sizeof(uint32), 
			0, (size_t)0, src->val);
}

/*--------------------------------------------------------------------*/
static INLINE void gmp2mp(mpz_t src, mp_t *dest) {

	size_t count;

	mp_clear(dest);
	mpz_export(dest->val, &count, -1, sizeof(uint32),
			0, (size_t)0, src);
	dest->nwords = count;
}

#ifdef __cplusplus
}
#endif

#endif /* _GMP_XFACE_H_ */

#endif /* HAVE_GMP */
